diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaiter.h ./win32/dependencies/cximage/ximaiter.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaiter.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximaiter.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,252 @@
+/*
+ * File:	ImaIter.h
+ * Purpose:	Declaration of the Platform Independent Image Base Class
+ * Author:	Alejandro Aguilar Sierra
+ * Created:	1995
+ * Copyright:	(c) 1995, Alejandro Aguilar Sierra <asierra(at)servidor(dot)unam(dot)mx>
+ *
+ * 07/08/2001 Davide Pizzolato - www.xdp.it
+ * - removed slow loops
+ * - added safe checks
+ *
+ * Permission is given by the author to freely redistribute and include
+ * this code in any program as long as this credit is given where due.
+ *
+ * COVERED CODE IS PROVIDED UNDER THIS LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTY
+ * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, WITHOUT LIMITATION, WARRANTIES
+ * THAT THE COVERED CODE IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE
+ * OR NON-INFRINGING. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE COVERED
+ * CODE IS WITH YOU. SHOULD ANY COVERED CODE PROVE DEFECTIVE IN ANY RESPECT, YOU (NOT
+ * THE INITIAL DEVELOPER OR ANY OTHER CONTRIBUTOR) ASSUME THE COST OF ANY NECESSARY
+ * SERVICING, REPAIR OR CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL
+ * PART OF THIS LICENSE. NO USE OF ANY COVERED CODE IS AUTHORIZED HEREUNDER EXCEPT UNDER
+ * THIS DISCLAIMER.
+ *
+ * Use at your own risk!
+ * ==========================================================
+ */
+
+#if !defined(__ImaIter_h)
+#define __ImaIter_h
+
+#include "ximage.h"
+#include "ximadef.h"
+
+class CImageIterator
+{
+friend class CxImage;
+protected:
+	int Itx, Ity;		// Counters
+	int Stepx, Stepy;
+	BYTE* IterImage;	//  Image pointer
+	CxImage *ima;
+public:
+	// Constructors
+	CImageIterator ( void );
+	CImageIterator ( CxImage *image );
+	operator CxImage* ();
+
+	// Iterators
+	BOOL ItOK ();
+	void Reset ();
+	void Upset ();
+	void SetRow(BYTE *buf, int n);
+	void GetRow(BYTE *buf, int n);
+	BYTE GetByte( ) { return IterImage[Itx]; }
+	void SetByte(BYTE b) { IterImage[Itx] = b; }
+	BYTE* GetRow(void);
+	BYTE* GetRow(int n);
+	BOOL NextRow();
+	BOOL PrevRow();
+	BOOL NextByte();
+	BOOL PrevByte();
+
+	void SetSteps(int x, int y=0) {  Stepx = x; Stepy = y; }
+	void GetSteps(int *x, int *y) {  *x = Stepx; *y = Stepy; }
+	BOOL NextStep();
+	BOOL PrevStep();
+
+	void SetY(int y);	/* AD - for interlace */
+	int  GetY() {return Ity;}
+	BOOL GetCol(BYTE* pCol, DWORD x);
+	BOOL SetCol(BYTE* pCol, DWORD x);
+};
+
+/////////////////////////////////////////////////////////////////////
+inline
+CImageIterator::CImageIterator(void)
+{
+	ima = 0;
+	IterImage = 0;
+	Itx = Ity = 0;
+	Stepx = Stepy = 0;
+}
+/////////////////////////////////////////////////////////////////////
+inline
+CImageIterator::CImageIterator(CxImage *imageImpl): ima(imageImpl)
+{
+	if (ima) IterImage = ima->GetBits();
+	Itx = Ity = 0;
+	Stepx = Stepy = 0;
+}
+/////////////////////////////////////////////////////////////////////
+inline
+CImageIterator::operator CxImage* ()
+{
+	return ima;
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::ItOK ()
+{
+	if (ima) return ima->IsInside(Itx, Ity);
+	else	 return FALSE;
+}
+/////////////////////////////////////////////////////////////////////
+inline void CImageIterator::Reset()
+{
+	if (ima) IterImage = ima->GetBits();
+	else	 IterImage=0;
+	Itx = Ity = 0;
+}
+/////////////////////////////////////////////////////////////////////
+inline void CImageIterator::Upset()
+{
+	Itx = 0;
+	Ity = ima->GetHeight()-1;
+	IterImage = ima->GetBits() + ima->GetEffWidth()*(ima->GetHeight()-1);
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::NextRow()
+{
+	if (++Ity >= (int)ima->GetHeight()) return 0;
+	IterImage += ima->GetEffWidth();
+	return 1;
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::PrevRow()
+{
+	if (--Ity < 0) return 0;
+	IterImage -= ima->GetEffWidth();
+	return 1;
+}
+/* AD - for interlace */
+inline void CImageIterator::SetY(int y)
+{
+	if ((y < 0) || (y > (int)ima->GetHeight())) return;
+	Ity = y;
+	IterImage = ima->GetBits() + ima->GetEffWidth()*y;
+}
+/////////////////////////////////////////////////////////////////////
+inline void CImageIterator::SetRow(BYTE *buf, int n)
+{
+	if (n<0) n = (int)ima->GetEffWidth();
+	else n = min(n,(int)ima->GetEffWidth());
+
+	if ((IterImage!=NULL)&&(buf!=NULL)&&(n>0)) memcpy(IterImage,buf,n);
+}
+/////////////////////////////////////////////////////////////////////
+inline void CImageIterator::GetRow(BYTE *buf, int n)
+{
+	if ((IterImage!=NULL)&&(buf!=NULL)&&(n>0)) memcpy(buf,IterImage,n);
+}
+/////////////////////////////////////////////////////////////////////
+inline BYTE* CImageIterator::GetRow()
+{
+	return IterImage;
+}
+/////////////////////////////////////////////////////////////////////
+inline BYTE* CImageIterator::GetRow(int n)
+{
+	SetY(n);
+	return IterImage;
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::NextByte()
+{
+	if (++Itx < (int)ima->GetEffWidth()) return 1;
+	else
+		if (++Ity < (int)ima->GetHeight()){
+			IterImage += ima->GetEffWidth();
+			Itx = 0;
+			return 1;
+		} else
+			return 0;
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::PrevByte()
+{
+  if (--Itx >= 0) return 1;
+  else
+	  if (--Ity >= 0){
+		  IterImage -= ima->GetEffWidth();
+		  Itx = 0;
+		  return 1;
+	  } else
+		  return 0;
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::NextStep()
+{
+	Itx += Stepx;
+	if (Itx < (int)ima->GetEffWidth()) return 1;
+	else {
+		Ity += Stepy;
+		if (Ity < (int)ima->GetHeight()){
+			IterImage += ima->GetEffWidth();
+			Itx = 0;
+			return 1;
+		} else
+			return 0;
+	}
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::PrevStep()
+{
+	Itx -= Stepx;
+	if (Itx >= 0) return 1;
+	else {       
+		Ity -= Stepy;
+		if (Ity >= 0 && Ity < (int)ima->GetHeight()) {
+			IterImage -= ima->GetEffWidth();
+			Itx = 0;
+			return 1;
+		} else
+			return 0;
+	}
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::GetCol(BYTE* pCol, DWORD x)
+{
+	if ((pCol==0)||(ima->GetBpp()<8)||(x>=ima->GetWidth()))
+		return 0;
+	DWORD h = ima->GetHeight();
+	//DWORD line = ima->GetEffWidth();
+	BYTE bytes = ima->GetBpp()>>3;
+	BYTE* pSrc;
+	for (DWORD y=0;y<h;y++){
+		pSrc = ima->GetBits(y) + x*bytes;
+		for (BYTE w=0;w<bytes;w++){
+			*pCol++=*pSrc++;
+		}
+	}
+	return 1;
+}
+/////////////////////////////////////////////////////////////////////
+inline BOOL CImageIterator::SetCol(BYTE* pCol, DWORD x)
+{
+	if ((pCol==0)||(ima->GetBpp()<8)||(x>=ima->GetWidth()))
+		return 0;
+	DWORD h = ima->GetHeight();
+	//DWORD line = ima->GetEffWidth();
+	BYTE bytes = ima->GetBpp()>>3;
+	BYTE* pSrc;
+	for (DWORD y=0;y<h;y++){
+		pSrc = ima->GetBits(y) + x*bytes;
+		for (BYTE w=0;w<bytes;w++){
+			*pSrc++=*pCol++;
+		}
+	}
+	return 1;
+}
+/////////////////////////////////////////////////////////////////////
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaj2k.cpp ./win32/dependencies/cximage/ximaj2k.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaj2k.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximaj2k.cpp	2006-08-24 07:16:02 +0900
@@ -0,0 +1,250 @@
+/*
+ * File:	ximaj2k.cpp
+ * Purpose:	Platform Independent J2K Image Class Loader and Writer
+ * 12/Jul/2002 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximaj2k.h"
+
+#if CXIMAGE_SUPPORT_J2K
+
+#define CEILDIV(a,b) ((a+b-1)/b)
+
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJ2K::Decode(CxFile *hFile)
+{
+	if (hFile == NULL) return false;
+
+  try
+  {
+	BYTE* src;
+	long len;
+	j2k_image_t *img=NULL;
+	j2k_cp_t *cp=NULL;
+	long i,x,y,w,h,max;
+
+	len=hFile->Size();
+	src=(BYTE*)malloc(len);
+	hFile->Read(src, len, 1);
+
+	if (!j2k_decode(src, len, &img, &cp)) {
+		free(src);
+		throw "failed to decode J2K image!";
+	}
+
+	free(src);
+
+    if (img->numcomps==3 &&
+		img->comps[0].dx==img->comps[1].dx &&
+		img->comps[1].dx==img->comps[2].dx &&
+		img->comps[0].dy==img->comps[1].dy &&
+		img->comps[1].dy==img->comps[2].dy &&
+		img->comps[0].prec==img->comps[1].prec &&
+		img->comps[1].prec==img->comps[2].prec)
+	{
+        w=CEILDIV(img->x1-img->x0, img->comps[0].dx);
+        h=CEILDIV(img->y1-img->y0, img->comps[0].dy);
+        max=(1<<img->comps[0].prec)-1;
+
+		Create(w,h,24,CXIMAGE_FORMAT_J2K);
+
+		RGBQUAD c;
+        for (i=0,y=0; y<h; y++) {
+			for (x=0; x<w; x++,i++){
+				c.rgbRed   = img->comps[0].data[i];
+				c.rgbGreen = img->comps[1].data[i];
+				c.rgbBlue  = img->comps[2].data[i];
+				SetPixelColor(x,h-1-y,c);
+			}
+		}
+	} else {
+		int compno;
+		info.nNumFrames = img->numcomps;
+		if ((info.nFrame<0)||(info.nFrame>=info.nNumFrames)){
+			j2k_destroy(&img,&cp);
+			throw "wrong frame!";
+		}
+		for (compno=0; compno<=info.nFrame; compno++) {
+			w=CEILDIV(img->x1-img->x0, img->comps[compno].dx);
+			h=CEILDIV(img->y1-img->y0, img->comps[compno].dy);
+			max=(1<<img->comps[compno].prec)-1;
+			Create(w,h,8,CXIMAGE_FORMAT_J2K);
+			SetGrayPalette();
+			for (i=0,y=0; y<h; y++) {
+				for (x=0; x<w; x++,i++){
+					SetPixelIndex(x,h-1-y,img->comps[compno].data[i]);
+				}
+			}
+		}
+	}
+
+	j2k_destroy(&img,&cp);
+
+  } catch (char *message) {
+	strncpy(info.szLastError,message,255);
+	return FALSE;
+  }
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJ2K::Encode(CxFile * hFile)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	if (head.biClrUsed!=0 && !IsGrayScale()){
+		strcpy(info.szLastError,"J2K can save only RGB or GrayScale images");
+		return false;
+	}
+
+    int i,x,y;
+    j2k_image_t *img;
+    j2k_cp_t *cp;
+    j2k_tcp_t *tcp;
+    j2k_tccp_t *tccp;
+
+	img = (j2k_image_t *)calloc(sizeof(j2k_image_t),1);
+	cp = (j2k_cp_t *)calloc(sizeof(j2k_cp_t),1);
+
+    cp->tx0=0; cp->ty0=0;
+    cp->tw=1; cp->th=1;
+    cp->tcps=(j2k_tcp_t*)calloc(sizeof(j2k_tcp_t),1);
+    tcp=&cp->tcps[0];
+
+	long w=head.biWidth;
+	long h=head.biHeight;
+ 
+	tcp->numlayers=1;
+	for (i=0;i<tcp->numlayers;i++) tcp->rates[i]=(w*h*GetJpegQuality())/600;
+
+
+    if (IsGrayScale()) {
+        img->x0=0;
+		img->y0=0;
+		img->x1=w;
+		img->y1=h;
+        img->numcomps=1;
+        img->comps=(j2k_comp_t*)calloc(sizeof(j2k_comp_t),1);
+        img->comps[0].data=(int*)calloc(w*h*sizeof(int),1);
+        img->comps[0].prec=8;
+        img->comps[0].sgnd=0;
+        img->comps[0].dx=1;
+        img->comps[0].dy=1;
+		for (i=0,y=0; y<h; y++) {
+			for (x=0; x<w; x++,i++){
+				img->comps[0].data[i]=GetPixelIndex(x,h-1-y);
+			}
+		}
+    } else if (!IsIndexed()) {
+        img->x0=0;
+		img->y0=0;
+		img->x1=w;
+		img->y1=h;
+        img->numcomps=3;
+        img->comps=(j2k_comp_t*)calloc(img->numcomps*sizeof(j2k_comp_t),1);
+        for (i=0; i<img->numcomps; i++) {
+            img->comps[i].data=(int*)calloc(w*h*sizeof(int),1);
+            img->comps[i].prec=8;
+            img->comps[i].sgnd=0;
+            img->comps[i].dx=1;
+            img->comps[i].dy=1;
+        }
+		RGBQUAD c;
+        for (i=0,y=0; y<h; y++) {
+			for (x=0; x<w; x++,i++){
+				c=GetPixelColor(x,h-1-y);
+				img->comps[0].data[i]=c.rgbRed;
+				img->comps[1].data[i]=c.rgbGreen;
+				img->comps[2].data[i]=c.rgbBlue;
+			}
+		}
+    } else {
+        return 0;
+    }
+	
+    cp->tdx=img->x1-img->x0;
+	cp->tdy=img->y1-img->y0;
+
+    tcp->csty=0;
+    tcp->prg=0;
+    tcp->mct=img->numcomps==3?1:0;
+    tcp->tccps=(j2k_tccp_t*)calloc(img->numcomps*sizeof(j2k_tccp_t),1);
+
+    int ir=0; /* or 1 ???*/
+
+    for (i=0; i<img->numcomps; i++) {
+        tccp=&tcp->tccps[i];
+        tccp->csty=0;
+        tccp->numresolutions=6;
+        tccp->cblkw=6;
+        tccp->cblkh=6;
+        tccp->cblksty=0;
+        tccp->qmfbid=ir?0:1;
+        tccp->qntsty=ir?J2K_CCP_QNTSTY_SEQNT:J2K_CCP_QNTSTY_NOQNT;
+        tccp->numgbits=2;
+        tccp->roishift=0;
+        j2k_calc_explicit_stepsizes(tccp, img->comps[i].prec);
+    }
+
+    BYTE* dest=(BYTE*)calloc(tcp->rates[tcp->numlayers-1]+2,1);
+    long len = j2k_encode(img, cp, dest, tcp->rates[tcp->numlayers-1]+2);
+
+    if (len==0) {
+		strcpy(info.szLastError,"J2K failed to encode image");
+    } else {
+		hFile->Write(dest, len, 1);
+	}
+	
+	free(dest);
+	j2k_destroy(&img,&cp);
+
+	return (len!=0);
+}
+////////////////////////////////////////////////////////////////////////////////
+
+static const double dwt_norms_97[4][10]={
+    {1.000, 1.965, 4.177, 8.403, 16.90, 33.84, 67.69, 135.3, 270.6, 540.9},
+    {2.022, 3.989, 8.355, 17.04, 34.27, 68.63, 137.3, 274.6, 549.0},
+    {2.022, 3.989, 8.355, 17.04, 34.27, 68.63, 137.3, 274.6, 549.0},
+    {2.080, 3.865, 8.307, 17.18, 34.71, 69.59, 139.3, 278.6, 557.2}
+};
+
+////////////////////////////////////////////////////////////////////////////////
+void CxImageJ2K::j2k_calc_explicit_stepsizes(j2k_tccp_t *tccp, int prec) {
+    int numbands, bandno;
+    numbands=3*tccp->numresolutions-2;
+    for (bandno=0; bandno<numbands; bandno++) {
+        double stepsize;
+
+        int resno, level, orient, gain;
+        resno=bandno==0?0:(bandno-1)/3+1;
+        orient=bandno==0?0:(bandno-1)%3+1;
+        level=tccp->numresolutions-1-resno;
+        gain=tccp->qmfbid==0?0:(orient==0?0:(orient==1||orient==2?1:2));
+        if (tccp->qntsty==J2K_CCP_QNTSTY_NOQNT) {
+            stepsize=1.0;
+        } else {
+            double norm=dwt_norms_97[orient][level];
+            stepsize=(1<<(gain+1))/norm;
+        }
+        j2k_encode_stepsize((int)floor(stepsize*8192.0), prec+gain, &tccp->stepsizes[bandno].expn, &tccp->stepsizes[bandno].mant);
+    }
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImageJ2K::j2k_encode_stepsize(int stepsize, int numbps, int *expn, int *mant) {
+    int p, n;
+    p=j2k_floorlog2(stepsize)-13;
+    n=11-j2k_floorlog2(stepsize);
+    *mant=(n<0?stepsize>>-n:stepsize<<n)&0x7ff;
+    *expn=numbps-p;
+}
+////////////////////////////////////////////////////////////////////////////////
+int CxImageJ2K::j2k_floorlog2(int a) {
+    int l;
+    for (l=0; a>1; l++) {
+        a>>=1;
+    }
+    return l;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif 	// CXIMAGE_SUPPORT_J2K
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaj2k.h ./win32/dependencies/cximage/ximaj2k.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaj2k.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximaj2k.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,46 @@
+/*
+ * File:	ximaj2k.h
+ * Purpose:	J2K Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageJ2K (c) 04/Aug/2002 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * based on LIBJ2K Copyright (c) 2001-2002, David Janssens - All rights reserved.
+ * ==========================================================
+ */
+#if !defined(__ximaJ2K_h)
+#define __ximaJ2K_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_J2K
+
+#define LIBJ2K_EXPORTS
+extern "C" {
+#include "../j2k/j2k.h"
+};
+
+class CxImageJ2K: public CxImage
+{
+public:
+	CxImageJ2K(): CxImage(CXIMAGE_FORMAT_J2K) {}
+
+//	bool Load(const char * imageFileName){ return CxImage::Load(imageFileName,CXIMAGE_FORMAT_J2K);}
+//	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,CXIMAGE_FORMAT_J2K);}
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+protected:
+	void j2k_calc_explicit_stepsizes(j2k_tccp_t *tccp, int prec);
+	void j2k_encode_stepsize(int stepsize, int numbps, int *expn, int *mant);
+	int j2k_floorlog2(int a);
+};
+
+#endif
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajas.cpp ./win32/dependencies/cximage/ximajas.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajas.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximajas.cpp	2006-08-24 07:16:02 +0900
@@ -0,0 +1,265 @@
+/*
+ * File:	ximajas.cpp
+ * Purpose:	Platform Independent JasPer Image Class Loader and Writer
+ * 12/Apr/2003 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximajas.h"
+
+#if CXIMAGE_SUPPORT_JASPER
+
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJAS::Decode(CxFile *hFile, DWORD imagetype)
+{
+	if (hFile == NULL) return false;
+
+	jas_image_t *image=0;
+	jas_stream_t *in=0;
+	jas_matrix_t **bufs=0;
+	long i,error=0;
+	//jas_setdbglevel(0);
+
+  try
+  {
+	if (jas_init())
+		throw "cannot initialize jasper";
+
+	if (!(in = jas_stream_fdopen(0, "rb")))
+		throw "error: cannot open standard input";
+
+	CxFileJas src(hFile,in);
+
+	if (!(image = jas_image_decode(in, -1, 0))) 
+		throw "error: cannot load image data";
+
+	long x,y,w,h,depth,cmptno;
+
+	w = jas_image_cmptwidth(image,0);
+	h = jas_image_cmptheight(image,0);
+	depth = jas_image_cmptprec(image,0);
+
+	if (image->numcmpts_ > 64 || image->numcmpts_ < 0)
+		throw "error: too much components";
+
+	if (depth!=1 && depth!=4 && depth!=8){
+		jas_image_t *newimage;
+		jas_cmprof_t *outprof;
+		//jas_eprintf("forcing conversion to sRGB\n");
+		if (!(outprof = jas_cmprof_createfromclrspc(JAS_CLRSPC_SRGB))) {
+			throw "cannot create sRGB profile";
+		}
+		if (!(newimage = jas_image_chclrspc(image, outprof, JAS_CMXFORM_INTENT_PER))) {
+			throw "cannot convert to sRGB";
+		}
+		jas_image_destroy(image);
+		jas_cmprof_destroy(outprof);
+		image = newimage;
+	}
+
+	bufs = (jas_matrix_t **)calloc(image->numcmpts_, sizeof(jas_matrix_t**));
+	for (i = 0; i < image->numcmpts_; ++i) {
+		if (!(bufs[i] = jas_matrix_create(1, w))) {
+			throw "error: cannot allocate memory";
+		}
+	}
+
+	if (image->numcmpts_==3 &&
+		image->cmpts_[0]->width_ == image->cmpts_[1]->width_ &&
+		image->cmpts_[1]->width_ == image->cmpts_[2]->width_ &&
+		image->cmpts_[0]->height_ == image->cmpts_[1]->height_ &&
+		image->cmpts_[1]->height_ == image->cmpts_[2]->height_ &&
+		image->cmpts_[0]->prec_  == image->cmpts_[1]->prec_ &&
+		image->cmpts_[1]->prec_ == image->cmpts_[2]->prec_ )
+	{
+
+		if(!Create(w,h,24,imagetype))
+			throw "Can't allocate memory";
+
+		RGBQUAD c;
+        for (y=0; y<h; y++) {
+			for (cmptno = 0; cmptno < image->numcmpts_; ++cmptno) {
+				jas_image_readcmpt(image, cmptno, 0, y, w, 1, bufs[cmptno]);
+			}
+
+			for (x=0; x<w; x++){
+				c.rgbRed   = (jas_matrix_getv(bufs[0], x));
+				c.rgbGreen = (jas_matrix_getv(bufs[1], x));
+				c.rgbBlue  = (jas_matrix_getv(bufs[2], x));
+				SetPixelColor(x,h-1-y,c);
+			}
+		}
+	} else {
+		info.nNumFrames = image->numcmpts_;
+		if ((info.nFrame<0)||(info.nFrame>=info.nNumFrames)){
+			throw "wrong frame!";
+		}
+		for (cmptno=0; cmptno<=info.nFrame; cmptno++) {
+			w = jas_image_cmptwidth(image,cmptno);
+			h = jas_image_cmptheight(image,cmptno);
+			depth = jas_image_cmptprec(image,cmptno);
+			if (depth>8) depth=8;
+			if(!Create(w,h,depth,imagetype))
+				throw "Can't allocate memory";
+			SetGrayPalette();
+			for (y=0; y<h; y++) {
+				jas_image_readcmpt(image, cmptno, 0, y, w, 1, bufs[0]);
+				for (x=0; x<w; x++){
+					SetPixelIndex(x,h-1-y,(jas_matrix_getv(bufs[0], x)));
+				}
+			}
+		}
+	}
+
+
+  } catch (char *message) {
+	strncpy(info.szLastError,message,255);
+	error = 1;
+  }
+
+	if (bufs) {
+		for (i = 0; i < image->numcmpts_; ++i){	if (bufs[i]) jas_matrix_destroy(bufs[i]);}
+		free(bufs);
+	}
+	jas_cleanup();
+	if (image) jas_image_destroy(image);
+	if (in) jas_stream_close(in);
+	return (error==0);
+}
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJAS::Encode(CxFile * hFile, DWORD imagetype)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	if (head.biClrUsed!=0 && !IsGrayScale()){
+		strcpy(info.szLastError,"JasPer can save only RGB or GrayScale images");
+		return false;
+	}
+
+	jas_image_t *image=0;
+	jas_stream_t *out=0;
+	jas_matrix_t *cmpts[3];
+	long x,y,yflip,error=0;
+	uint_fast16_t cmptno, numcmpts;
+	jas_image_cmptparm_t cmptparms[3], *cmptparm;
+
+  try
+  {
+
+	if (jas_init())
+		throw "cannot initialize jasper";
+
+	if (!(out = jas_stream_fdopen(0, "wb")))
+		throw "error: cannot open standard output";
+
+	CxFileJas src(hFile,out);
+
+	numcmpts = head.biClrUsed==0 ? 3 : 1;
+
+	for (cmptno = 0, cmptparm = cmptparms; cmptno < numcmpts; ++cmptno, ++cmptparm) {
+		cmptparm->tlx = 0;
+		cmptparm->tly = 0;
+		cmptparm->hstep = 1;
+		cmptparm->vstep = 1;
+		cmptparm->width = head.biWidth;
+		cmptparm->height = head.biHeight;
+		cmptparm->prec = 8;
+		cmptparm->sgnd = false;
+	}
+
+	/* Create image object. */
+	if (!(image = jas_image_create(numcmpts, cmptparms, JAS_CLRSPC_UNKNOWN)))
+		throw "error : jas_image_create";
+
+	if (numcmpts == 3) {
+		jas_image_setclrspc(image, JAS_CLRSPC_SRGB);
+		jas_image_setcmpttype(image, 0,
+		  JAS_IMAGE_CT_COLOR(JAS_CLRSPC_CHANIND_RGB_R));
+		jas_image_setcmpttype(image, 1,
+		  JAS_IMAGE_CT_COLOR(JAS_CLRSPC_CHANIND_RGB_G));
+		jas_image_setcmpttype(image, 2,
+		  JAS_IMAGE_CT_COLOR(JAS_CLRSPC_CHANIND_RGB_B));
+	} else {
+		jas_image_setclrspc(image, JAS_CLRSPC_SGRAY);
+		jas_image_setcmpttype(image, 0,
+		  JAS_IMAGE_CT_COLOR(JAS_CLRSPC_CHANIND_GRAY_Y));
+	}
+
+
+	for (x = 0; x < numcmpts; ++x) { cmpts[x] = 0; }
+	/* Create temporary matrices to hold component data. */
+	for (x = 0; x < numcmpts; ++x) {
+		if (!(cmpts[x] = jas_matrix_create(1, head.biWidth))) {
+			throw "error : can't allocate memory";
+		}
+	}
+
+	RGBQUAD c;
+	for (y = 0; y < head.biHeight; ++y) {
+		for (x = 0; x < head.biWidth; ++x) {
+			if (head.biClrUsed==0){
+				c = GetPixelColor(x,y);
+				jas_matrix_setv(cmpts[0], x, c.rgbRed);
+				jas_matrix_setv(cmpts[1], x, c.rgbGreen);
+				jas_matrix_setv(cmpts[2], x, c.rgbBlue);
+			} else {
+				jas_matrix_setv(cmpts[0], x, GetPixelIndex(x,y));
+			}
+		}
+		yflip = head.biHeight - 1 - y;
+		for (cmptno = 0; cmptno < numcmpts; ++cmptno) {
+			if (jas_image_writecmpt(image, cmptno, 0, yflip, head.biWidth, 1, cmpts[cmptno])) {
+				throw "error : jas_image_writecmpt";
+			}
+		}
+	}
+
+	 char szfmt[4];
+	*szfmt = '\0';
+#if CXIMAGE_SUPPORT_JP2
+	if (imagetype == CXIMAGE_FORMAT_JP2) strcpy(szfmt,"jp2");
+#endif
+#if CXIMAGE_SUPPORT_JPC
+	if (imagetype == CXIMAGE_FORMAT_JPC) strcpy(szfmt,"jpc");
+#endif
+#if CXIMAGE_SUPPORT_RAS
+	if (imagetype == CXIMAGE_FORMAT_RAS) strcpy(szfmt,"ras");
+#endif
+#if CXIMAGE_SUPPORT_PNM
+	if (imagetype == CXIMAGE_FORMAT_PNM) strcpy(szfmt,"pnm");
+#endif
+#if CXIMAGE_SUPPORT_PGX
+	if (imagetype == CXIMAGE_FORMAT_PGX){
+		strcpy(szfmt,"pgx");
+		if (head.biClrUsed==0) throw "PGX can save only GrayScale images";
+	}
+#endif
+	int outfmt = jas_image_strtofmt(szfmt);
+
+	char szoutopts[16];
+	sprintf(szoutopts,"rate=%.3f", info.nQuality/100.0f);
+
+	if (jas_image_encode(image, out, outfmt, szoutopts)) {
+		throw "error: cannot encode image\n";
+	}
+	jas_stream_flush(out);
+
+  } catch (char *message) {
+	strncpy(info.szLastError,message,255);
+	error = 1;
+  }
+
+	for (x = 0; x < numcmpts; ++x) { if (cmpts[x]) { jas_matrix_destroy(cmpts[x]); } }
+	jas_cleanup();
+	if (image) jas_image_destroy(image);
+	if (out) jas_stream_close(out);
+
+	return (error==0);
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_JASPER
+
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajas.h ./win32/dependencies/cximage/ximajas.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajas.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximajas.h	2006-08-24 07:16:03 +0900
@@ -0,0 +1,84 @@
+/*
+ * File:	ximajas.h
+ * Purpose:	Jasper Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageJAS (c) 12/Apr/2003 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * based on JasPer Copyright (c) 2001-2003 Michael David Adams - All rights reserved.
+ * ==========================================================
+ */
+#if !defined(__ximaJAS_h)
+#define __ximaJAS_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_JASPER
+
+#include "../jasper/include/jasper/jasper.h"
+
+class CxImageJAS: public CxImage
+{
+public:
+	CxImageJAS(): CxImage((DWORD)0) {}	// <vho> cast to DWORD
+
+//	bool Load(const char * imageFileName){ return CxImage::Load(imageFileName,0);}
+//	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,0);}
+	bool Decode(CxFile * hFile, DWORD imagetype = 0);
+	bool Decode(FILE *hFile, DWORD imagetype = 0) { CxIOFile file(hFile); return Decode(&file,imagetype); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile, DWORD imagetype = 0);
+	bool Encode(FILE *hFile, DWORD imagetype = 0) { CxIOFile file(hFile); return Encode(&file,imagetype); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+protected:
+
+	class CxFileJas
+	{
+	public:
+		CxFileJas(CxFile* pFile,jas_stream_t *stream)
+		{
+			if (stream->obj_) jas_free(stream->obj_);
+			stream->obj_ = pFile;
+
+			// <vho> - cannot set the stream->ops_->functions here,
+			// because this overwrites a static structure in the Jasper library.
+			// This structure is used by Jasper for internal operations too, e.g. tempfile.
+			// However the ops_ pointer in the stream can be overwritten.
+
+			//stream->ops_->close_ = JasClose;
+			//stream->ops_->read_  = JasRead;
+			//stream->ops_->seek_  = JasSeek;
+			//stream->ops_->write_ = JasWrite;
+
+			jas_stream_CxFile.close_ = JasClose;
+			jas_stream_CxFile.read_  = JasRead;
+			jas_stream_CxFile.seek_  = JasSeek;
+			jas_stream_CxFile.write_ = JasWrite;
+
+			stream->ops_ = &jas_stream_CxFile;
+
+			// <vho> - end
+		}
+		static int JasRead(jas_stream_obj_t *obj, char *buf, int cnt)
+		{		return ((CxFile*)obj)->Read(buf,1,cnt); }
+		static int JasWrite(jas_stream_obj_t *obj, char *buf, int cnt)
+		{		return ((CxFile*)obj)->Write(buf,1,cnt); }
+		static long JasSeek(jas_stream_obj_t *obj, long offset, int origin)
+		{		return ((CxFile*)obj)->Seek(offset,origin); }
+		static int JasClose(jas_stream_obj_t *obj)
+		{		return 1; }
+
+	// <vho>
+	private:
+		jas_stream_ops_t jas_stream_CxFile;
+	// <vho> - end
+
+	};
+
+};
+
+#endif
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajbg.cpp ./win32/dependencies/cximage/ximajbg.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajbg.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximajbg.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,162 @@
+/*
+ * File:	ximajbg.cpp
+ * Purpose:	Platform Independent JBG Image Class Loader and Writer
+ * 18/Aug/2002 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximajbg.h"
+
+#if CXIMAGE_SUPPORT_JBG
+
+#include "ximaiter.h"
+
+#define JBIG_BUFSIZE 8192
+
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJBG::Decode(CxFile *hFile)
+{
+	if (hFile == NULL) return false;
+
+	struct jbg_dec_state jbig_state;
+	unsigned long xmax = 4294967295UL, ymax = 4294967295UL;
+	unsigned int len, cnt;
+	BYTE *buffer,*p;
+	int result;
+
+  try
+  {
+	jbg_dec_init(&jbig_state);
+	jbg_dec_maxsize(&jbig_state, xmax, ymax);
+
+	buffer = (BYTE*)malloc(JBIG_BUFSIZE);
+	if (!buffer) throw "Sorry, not enough memory available!";
+
+	result = JBG_EAGAIN;
+	do {
+		len = hFile->Read(buffer, 1, JBIG_BUFSIZE);
+		if (!len) break;
+		cnt = 0;
+		p = buffer;
+		while (len > 0 && (result == JBG_EAGAIN || result == JBG_EOK)) {
+			result = jbg_dec_in(&jbig_state, p, len, &cnt);
+			p += cnt;
+			len -= cnt;
+		}
+	} while (result == JBG_EAGAIN || result == JBG_EOK);
+
+	if (hFile->Error())
+		throw "Problem while reading input file";
+	if (result != JBG_EOK && result != JBG_EOK_INTR)
+		throw "Problem with input file"; 
+
+	int w, h, bpp, planes, ew;
+
+	w = jbg_dec_getwidth(&jbig_state);
+	h = jbg_dec_getheight(&jbig_state);
+	planes = jbg_dec_getplanes(&jbig_state);
+	bpp = (planes+7)>>3;
+	ew = (w + 7)>>3;
+
+	switch (planes){
+	case 1:
+		{
+			BYTE* binary_image = jbg_dec_getimage(&jbig_state, 0);
+
+			if (!Create(w,h,1,CXIMAGE_FORMAT_JBG))
+				throw "Can't allocate memory";
+
+			SetPaletteColor(0,255,255,255);
+			SetPaletteColor(1,0,0,0);
+
+			CImageIterator iter(this);
+			iter.Upset();
+			for (int i=0;i<h;i++){
+				iter.SetRow(binary_image+i*ew,ew);
+				iter.PrevRow();
+			}
+
+			break;
+		}
+	default:
+		throw "cannot decode images with more than 1 plane";
+	}
+
+	jbg_dec_free(&jbig_state);
+	free(buffer);
+
+  } catch (char *message) {
+	jbg_dec_free(&jbig_state);
+	if (buffer) free(buffer);
+	strncpy(info.szLastError,message,255);
+	return FALSE;
+  }
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJBG::Encode(CxFile * hFile)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	if (head.biBitCount != 1){
+		strcpy(info.szLastError,"JBG can save only 1-bpp images");
+		return false;
+	}
+
+	int w, h, bpp, planes, ew, i, j, x, y;
+
+	w = head.biWidth;
+	h = head.biHeight;
+	planes = 1;
+	bpp = (planes+7)>>3;
+	ew = (w + 7)>>3;
+
+	BYTE mask;
+	RGBQUAD *rgb = GetPalette();
+	if (CompareColors(&rgb[0],&rgb[1])<0) mask=255; else mask=0;
+
+	BYTE *buffer = (BYTE*)malloc(ew*h*2);
+	if (!buffer) {
+		strcpy(info.szLastError,"Sorry, not enough memory available!");
+		return false;
+	}
+
+	for (y=0; y<h; y++){
+		i= y*ew;
+		j= (h-y-1)*info.dwEffWidth;
+		for (x=0; x<ew; x++){
+			buffer[i + x]=info.pImage[j + x]^mask;
+		}
+	}
+
+	struct jbg_enc_state jbig_state;
+	jbg_enc_init(&jbig_state, w, h, planes, &buffer, jbig_data_out, hFile);
+
+    //jbg_enc_layers(&jbig_state, 2);
+    //jbg_enc_lrlmax(&jbig_state, 800, 600);
+
+	// Specify a few other options (each is ignored if negative)
+	int dl = -1, dh = -1, d = -1, l0 = -1, mx = -1;
+	int options = JBG_TPDON | JBG_TPBON | JBG_DPON;
+	int order = JBG_ILEAVE | JBG_SMID;
+	jbg_enc_lrange(&jbig_state, dl, dh);
+	jbg_enc_options(&jbig_state, order, options, l0, mx, -1);
+
+	// now encode everything and send it to data_out()
+	jbg_enc_out(&jbig_state);
+
+	// give encoder a chance to free its temporary data structures
+	jbg_enc_free(&jbig_state);
+
+	free(buffer);
+
+	if (hFile->Error()){
+		strcpy(info.szLastError,"Problem while writing JBG file");
+		return false;
+	}
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif 	// CXIMAGE_SUPPORT_JBG
+
